<?xml version='1.0' encoding='utf-8' ?>
<xsl:stylesheet 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html"/>

<!--

XSL stylesheet for displaying Audit and Security Package from MAGE-ML documents

Author: Philippe Rocca-Serra (rocca@ebi.ac.uk)

-->


	<xsl:template match="/">
		<h3><u>Quantitation Types</u></h3>
		<table border="1">
			<tr>
				<th>Identifier</th>
				<th>is Background</th>
				<th>Description</th>
				<th>Channel</th>
				<th>Scale</th>
				<th>Data Type</th>

			</tr>

	         <xsl:for-each select="//DerivedSignal | //MeasuredSignal | //PresentAbsent | //PValue | //Ratio | //SpecializedQuantitationType">

		    <tr>
		     <td><i><b>
		     <xsl:value-of select="@identifier"/></b></i>
		     </td>
		     <td><i><b>
		     <xsl:value-of select="@isBackground"/></b></i>
		     </td>

		    

   		         <td><span style="color:#111fff">
			  <xsl:value-of select="child::Descriptions_assnlist/Description/@text"/>
			 </span><br/>
 		         </td>

 


    			<td><span style="color:#111fff">
			<xsl:value-of select="child::Channel_assnref/Channel_ref/@identifier"/>
			</span><br/>
			</td>


    			<td><span style="color:#111fff">
			<xsl:value-of select="child::Scale_assn/OntologyEntry/@value"/>
			</span><br/>
			</td>


    			<td><span style="color:#111fff">
			<xsl:value-of select="child::DataType_assn/OntologyEntry/@value"/>
			</span><br/>
			</td>

	           </tr>
		  </xsl:for-each>
		</table>
	</xsl:template>
</xsl:stylesheet>