/*
	$Id: AccountExpiredException.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

import java.util.Date;

/**
	This exception is thrown if you try to log in
	with an account that has expired.

	@author Nicklas
	@version 2.0
*/
public class AccountExpiredException
	extends PermissionDeniedException
{

	/**
		
	*/
	private static final long serialVersionUID = 3521477904486961158L;

	/**
		Creates a new <code>AccountExpiredException</code>.
	  	@param login Login name for the expired account 
	 	@param expirationDate Date when the account expired.
	*/
	public AccountExpiredException(String login, Date expirationDate)
	{
		super("The account has expired: "+login+"[expirationDate="+expirationDate+"]");
	}

}


