/**
	$Id: BioMaterialSourceEventData.java 4517 2008-09-11 20:11:02Z jari $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This class is needed to be able to map the inverse relation
	{@link MeasuredBioMaterialData#getSourceEvents()} and still be able
	to filter in the used quantity or the source group property. This class
	is related to the {@link UsedQuantity} class which is used for the
	same relation in the other direction: {@link BioMaterialEventData#getSources()}.

	@author nicklas
	@version 2.6
	@base.modified $Date: 2008-09-11 22:11:02 +0200 (Thu, 11 Sep 2008) $
*/
public class BioMaterialSourceEventData
{

	public BioMaterialSourceEventData()
	{}
	
	private BioMaterialEventData event;
	/**
		@hibernate.many-to-one column="`event_id`" class="net.sf.basedb.core.data.BioMaterialEventData"
	*/
	public BioMaterialEventData getEvent()
	{
		return event;
	}
	public void setEvent(BioMaterialEventData event)
	{
		this.event = event;
	}
	
	private Float usedQuantity;
	/**
		@hibernate.property column="`used_quantity`" not-null="false" type="float"
	*/
	public Float getUsedQuantity()
	{
		return usedQuantity;
	}
	public void setUsedQuantity(Float usedQuantity)
	{
		this.usedQuantity = usedQuantity;
	}
	
	private int sourceGroup;
	/**
		@hibernate.property column="`dummy`" type="int" not-null="true"
	*/
	public int getSourceGroup()
	{
		return sourceGroup;
	}
	private void setSourceGroup(int sourceGroup)
	{
		this.sourceGroup = sourceGroup;
	}
	
	
	
}
