/**
	$Id: ExtendedPropertyInfo.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

import java.io.Serializable;

/**
 	Class to hold information about an extended property in Base 
 	{@link net.sf.basedb.core.ExtendedProperty}.
  	@author Martin
  	@since 2.5 	
 */
public class ExtendedPropertyInfo 
	implements Serializable, Transferable
{

	/**
		 
	*/
	private static final long serialVersionUID = 970921289373893596L;
	
	private String name;
	private String column;
	private String title;
	private String description;
	private int length;
	private boolean nullable;
	private boolean insertable;
	private boolean updateable;
	
	/**
	 	Creates an object with no property set.
	 */
	public ExtendedPropertyInfo()
	{}
	
	/**	
	  	@param name The name to set.
	*/
	public void setName(String name)
	{
		this.name = name;
	}
	/**	
	 	@return Returns the name.
	*/
	public String getName()
	{
		return name;
	}
	/**	
	  	@param column The column to set.
	*/
	public void setColumn(String column)
	{
		this.column = column;
	}
	/**	
	 	@return Returns the column.
	*/
	public String getColumn()
	{
		return column;
	}
	/**	
	  	@param title The title to set.
	*/
	public void setTitle(String title)
	{
		this.title = title;
	}
	/**	
	 	@return Returns the title.
	*/
	public String getTitle()
	{
		return title;
	}
	/**	
	  	@param description The description to set.
	*/
	public void setDescription(String description)
	{
		this.description = description;
	}
	/**	
	 	@return Returns the description.
	*/
	public String getDescription()
	{
		return description;
	}
	/**	
	  	@param length The length to set.
	*/
	public void setLength(int length)
	{
		this.length = length;
	}
	/**	
	 	@return Returns the length.
	*/
	public int getLength()
	{
		return length;
	}
	/**	
	  	@param nullable The nullable to set.
	*/
	public void setNullable(boolean nullable)
	{
		this.nullable = nullable;
	}
	/**	
	 	@return Returns the nullable.
	*/
	public boolean isNullable()
	{
		return nullable;
	}
	/**	
	  	@param insertable The insertable to set.
	*/
	public void setInsertable(boolean insertable)
	{
		this.insertable = insertable;
	}
	/**	
	 	@return Returns the insertable.
	*/
	public boolean isInsertable()
	{
		return insertable;
	}
	/**	
	  	@param updateable The updateable to set.
	*/
	public void setUpdateable(boolean updateable)
	{
		this.updateable = updateable;
	}
	/**	
	 	@return Returns the updateable.
	*/
	public boolean isUpdateable()
	{
		return updateable;
	}	

}
