/*
	$Id: TestXMLUtil.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
import net.sf.basedb.util.XMLUtil;

public class TestXMLUtil
{

	static boolean ok = true;
	public static void main(String[] args)
	{
		TestUtil.checkArgs(args);
		TestUtil.begin();
		ok = test_all();
		TestUtil.stop();
	}

	static boolean test_all()
	{
		write("++Testing XMLUtil");
		test_create_dom(TestXMLUtil.class.getResource("data/extended-properties.xml"), TestXMLUtil.class.getResource("data/extended-properties.dtd"));
		
		String schema = TestXMLUtil.class.getResource("data/test.schema.xsd").toString();
		test_create_schema_validated_dom(
				TestXMLUtil.class.getResource("data/test.schema.xml"), 
				"http://base.thep.lu.se/test.schema.xsd", schema);
		write("++Testing XMLUtil "+(ok ? "OK" : "Failed")+"\n");
		return ok;
	}

	
	static void test_create_dom(java.net.URL xmlFile, java.net.URL dtdFile)
	{
		try
		{
			org.jdom.Document dom = XMLUtil.getValidatedXml(xmlFile, dtdFile);
			if (!TestUtil.getSilent()) write(dom.toString());
			write("--Create DOM OK");
		}
		catch (Throwable ex)
		{
			write("--Create DOM FAILED");
			ex.printStackTrace();
			ok = false;
		}
	}
	
	static void test_create_schema_validated_dom(java.net.URL xmlFile, String... schemaFiles)
	{
		try
		{
			org.jdom.Document dom = XMLUtil.getSchemaValidatedXML(xmlFile, schemaFiles);
			if (!TestUtil.getSilent()) write(dom.toString());
			write("--Create schema validated DOM OK");
		}
		catch (Throwable ex)
		{
			write("--Create schema validated DOM FAILED");
			ex.printStackTrace();
			ok = false;
		}
	}
	

	static void write(String message)
	{
		System.out.println(message);
	}

}

