<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.DiskUsage"
	import="net.sf.basedb.core.DiskUsageStatistics"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DISKUSAGE;
	private static final String subContext = "perUser";
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST, subContext);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final boolean impersonatePermission = sc.hasSystemPermission(Permission.ACT_AS_ANOTHER_USER);
final boolean writePermission = sc.hasPermission(Permission.WRITE, Item.USER);
final String showStatistics = Values.getString(cc.getSetting("showStatistics"), 
	Application.hasSecondaryStorage() ? "full" : "quotaType");

final boolean hasLocation = "location".equals(showStatistics) || "full".equals(showStatistics);
final boolean hasQuotaType = "quotaType".equals(showStatistics) || "full".equals(showStatistics);

final DbControl dc = sc.newDbControl();
ItemResultIterator<User> users = null;
try
{
	DiskUsageStatistics du = (DiskUsageStatistics)sc.getSessionSetting("diskUsageStatistics");
	if (du == null)
	{
		du = DiskUsage.getStatistics(dc);
		sc.setSessionSetting("diskUsageStatistics", du);
	}
	du.setDbControl(dc);
	List<QuotaType> quotaTypes = du.getQuotaTypes();
	
	try
	{
		final ItemQuery<User> query = Base.getConfiguredQuery(cc, true, User.getQuery(), mode);
		query.include(Include.ALL);
		users = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="Disk usage">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'users';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', 'USER', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', 'USER', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function impersonate(userId)
		{
			Main.openPopup('../../impersonate.jsp?ID=<%=ID%>&user_id='+userId, 'Impersonate', 480, 240);
		}
		function setShowStatistics()
		{
			document.forms[formId].submit();
		}
		function viewDiskUsageDetails(userId)
		{
			location.href = 'details/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id='+userId+'&item_type=USER';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'overview')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=Overview';
			}
			else if (tabId == 'groups')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ListGroups';
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}		
		</script>
	</base:head>
	
	<base:body>
	
		<t:tabcontrol id="main" active="users" switch="switchTab">
		<t:tab id="overview" title="Overview" />
		
		<t:tab id="users" title="Per user">
	
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="users" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:hidden 
				name="subcontext"
				value="<%=subContext%>"
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="diskUsage"
				title="Disk usage summary"
				show="always"
			/>
			<tbl:columndef 
				id="login"
				clazz="uniquecol"
				property="login"
				datatype="string"
				title="Login"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="systemId"
				clazz="uniquecol"
				property="systemId"
				datatype="string"
				title="System ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="externalId"
				clazz="uniquecol"
				property="externalId"
				datatype="string"
				title="External ID"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="expirationDate"
				property="expirationDate"
				datatype="date"
				title="Expiration date"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=FormatterFactory.getDateFormatter(sc)%>"
			/>
			<tbl:columndef 
				id="disabled"
				property="disabled"
				datatype="boolean"
				title="Disabled"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="multiuserAccount"
				property="multiuserAccount"
				datatype="boolean"
				title="Multi-user account"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="organisation"
				property="organisation"
				datatype="string"
				title="Organisation"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="address"
				property="address"
				datatype="string"
				title="Address"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="email"
				property="email"
				datatype="string"
				title="Email"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="phone"
				property="phone"
				datatype="string"
				title="Phone"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="fax"
				property="fax"
				datatype="string"
				title="Fax"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="url"
				property="url"
				datatype="string"
				title="Url"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="quota"
				property="quota.name"
				datatype="string"
				title="Quota"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="quotagroup"
				property="quotaGroup.name"
				datatype="string"
				title="Quota group"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:panel>
				<b>Show summary</b>
				<input type="radio" name="showStatistics" value="total"
					<%="total".equals(showStatistics) ? "checked" : ""%>
					onclick="setShowStatistics()"><a
					href="javascript:document.forms[formId].showStatistics[0].click()">Total only</a>
				<input type="radio" name="showStatistics" value="location"
					<%="location".equals(showStatistics) ? "checked" : ""%>
					onclick="setShowStatistics()"><a
					href="javascript:document.forms[formId].showStatistics[1].click()">Per location</a>
				<input type="radio" name="showStatistics" value="quotaType"
					<%="quotaType".equals(showStatistics) ? "checked" : ""%>
					onclick="setShowStatistics()"><a
					href="javascript:document.forms[formId].showStatistics[2].click()">Per quota type</a>
				<input type="radio" name="showStatistics" value="full"
					<%="full".equals(showStatistics) ? "checked" : ""%>
					onclick="setShowStatistics()"><a
					href="javascript:document.forms[formId].showStatistics[3].click()">Full</a>
			</tbl:panel>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=users == null ? 0 : users.getTotalCount()%>" 
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>

				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
					
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (users != null)
					{						
						while (users.hasNext())
						{
							User item = users.next();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon
										image="login.png"
										tooltip="Login as this user"
										onclick="<%="impersonate(" + itemId + ")"%>"
										visible="<%=impersonatePermission%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="diskUsage">
									<%
									DiskUsageStatistics.Summary summary = du.getSummary(item);
									long total = summary.getTotal();
									if (total > 0 && (hasLocation || hasQuotaType))
									{
										%>
										<table border="0" cellspacing="0" cellpadding="2">
										<%
										if (hasLocation)
										{
											%>
											<tr>
												<%
												if (hasQuotaType)
												{
													%>
													<th>&nbsp;</th>
													<%
												}
												%>
												<th style="text-align: right;">Total</th>
												<td style="text-align: right;">&nbsp;&nbsp;Primary</td>
												<td style="text-align: right;">&nbsp;&nbsp;Secondary</td>
												<td style="text-align: right;">&nbsp;&nbsp;Offline</td>
												<td style="text-align: right;">&nbsp;&nbsp;External</td>
											</tr>
											<%
										}
										%>
										<tr>
											<td colspan="6" style="border-bottom: 1px dotted #999999"></td>
										</tr>		
										<tr style="background: #E0E0E0;">
											<%
											if (hasQuotaType)
											{
												%>
												<th>Total</th>
												<%
											}
											%>
											<td style="text-align: right;"><%=Values.formatBytes(total)%></td>
											<%
											if (hasLocation)
											{
												%>
												<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(Location.PRIMARY))%></td>
												<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(Location.SECONDARY))%></td>
												<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(Location.OFFLINE))%></td>
												<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(Location.EXTERNAL))%></td>
												<%
											}
											%>
										</tr>
										<tr>
											<td colspan="6" style="border-top: 1px dotted #999999"></td>
										</tr>		
										<%
										if (hasQuotaType && total > 0)
										{
											for (QuotaType qt : quotaTypes)
											{
												%>
												<tr>
													<td><%=HTML.encodeTags(qt.getName())%></td>
													<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(qt))%></td>
													<%
													if (hasLocation)
													{
														%>
														<td style="text-align: right;"><%=Values.formatBytes(summary.getTotal(qt, Location.PRIMARY))%></td>
														<td style="text-align: right;"><%=qt.hasSecondaryLocation() ? Values.formatBytes(summary.getTotal(qt, Location.SECONDARY)) : "n/a"%></td>
														<td style="text-align: right;"><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.OFFLINE)) : "n/a"%></td>
														<td style="text-align: right;"><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.EXTERNAL)) : "n/a"%></td>
														<%
													}
													%>
												</tr>
												<%
											}
										}
										%>
										</table>
										<%
									}
									else
									{
										%>
										<%=Values.formatBytes(total)%>
										<%
									}
									if (total > 0)
									{
										%>
										<base:icon image="bullet.gif" />
										<a href="javascript:viewDiskUsageDetails(<%=itemId%>)">View details</a>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="login"><%=HTML.encodeTags(item.getLogin())%></tbl:cell>
								<tbl:cell column="systemId"><%=Values.getString(item.getSystemId())%></tbl:cell>
								<tbl:cell column="externalId"><%=HTML.encodeTags(item.getExternalId())%></tbl:cell>
								<tbl:cell column="expirationDate" value="<%=item.getExpirationDate()%>" />
								<tbl:cell column="disabled"><%=item.isDisabled() ? "yes" : "no" %></tbl:cell>
								<tbl:cell column="multiuserAccount"><%=item.isMultiuserAccount() ? "yes" : "no" %></tbl:cell>
								<tbl:cell column="organisation"><%=HTML.encodeTags(item.getOrganisation())%></tbl:cell>
								<tbl:cell column="address"><%=HTML.encodeTags(item.getAddress())%></tbl:cell>
								<tbl:cell column="email"><%=HTML.encodeTags(item.getEmail())%></tbl:cell>
								<tbl:cell column="phone"><%=HTML.encodeTags(item.getPhone())%></tbl:cell>
								<tbl:cell column="fax"><%=HTML.encodeTags(item.getFax())%></tbl:cell>
								<tbl:cell column="url"><%=HTML.encodeTags(item.getUrl())%></tbl:cell>
								<tbl:cell column="quota"
									><base:propertyvalue 
										item="<%=item%>" 
										property="quota"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="quotagroup"
									><base:propertyvalue 
										item="<%=item%>" 
										property="quotaGroup"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
							}
						}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=users == null || users.getTotalCount() == 0 ? "No users were found" : "No users on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=users == null ? 0 : users.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		
		</t:tab>
		<t:tab id="groups" title="Per group" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (users != null) users.close();
	if (dc != null) dc.close();
}
%>
