<%-- $Id: edit_plugin.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.Permissions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.util.Values"
	import="java.util.EnumSet"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static final int DENY_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DENIED));
private static final int CREATE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.CREATE));
private static final int READ_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.READ));
private static final int USE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.USE));
private static final int WRITE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.WRITE));
private static final int DELETE_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.DELETE));
private static final int SET_OWNER_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_OWNER));
private static final int SET_PERMISSION_CODE = PermissionUtil.getPermissionCode(EnumSet.of(Permission.SET_PERMISSION));

private String getOption(DbControl dc, PluginDefinition plugin, Item itemType)
	throws BaseException
{
	int keyId = SystemItems.getRoleKeyId(itemType);
	if (keyId == 0) return "";

	RoleKey key = RoleKey.getById(dc, keyId);	
	StringBuilder sb = new StringBuilder();
	sb.append("<option value=\"").append(key.getItemType().name()).append("\">");
	sb.append(HTML.encodeTags(key.getName()));
	sb.append(" []");
	return sb.toString();
}
private void appendPermissionLetter(StringBuilder sb, Permission p, String letter, 
	Set<Permission> defined, Set<Permission> always, Set<Permission> maybe)
{
	if (defined != null && defined.contains(p))
	{
		if (always != null && always.contains(p))
		{
			sb.append(letter.toUpperCase());
		}
		else if (maybe != null && maybe.contains(p))
		{
			sb.append(letter.toLowerCase());
		}
		else
		{
			sb.append("-");
		}
	}
}
%>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PluginDefinition plugin = null;
	boolean isTrusted = true;
	Boolean allowImmediateExecution = null;
	boolean usePermissions = false;
	Collection<Permissions> requestedPermissions = null;
	String warning = null;
	
	final int selectedAgentId = Values.getInt(request.getParameter("jobagent_id"), -1);

	// Query to retrieve job agents
	ItemQuery<JobAgent> agentQuery = null;

	// Query to retrieve role keys
	final ItemQuery<RoleKey> roleKeyQuery = RoleKey.getQuery();
	roleKeyQuery.order(Orders.asc(Hql.property("name")));
	
	if (itemId == 0)
	{
		title = "Create plugin";
		cc.removeObject("item");
		String tt = cc.getPropertyValue("trusted");
		String up = cc.getPropertyValue("usePermissions");
		String aie = cc.getPropertyValue("allowImmediateExection");
		isTrusted = tt == null ? isTrusted : Values.getBoolean(tt);
		usePermissions = up == null ? usePermissions : Values.getBoolean(up);
		allowImmediateExecution = aie == null ? null : Values.getBoolean(aie);
	}
	else
	{
		plugin = PluginDefinition.getById(dc, itemId);
		cc.setObject("item", plugin);
		title = "Edit plugin -- " + HTML.encodeTags(plugin.getName());
		plugin.checkPermission(Permission.WRITE);
		isTrusted = plugin.isTrusted();
		usePermissions = plugin.getUsePermissions();
		allowImmediateExecution = plugin.getAllowImmediateExecution();

		agentQuery = JobAgent.getQuery();
		agentQuery.include(Include.ALL);
		agentQuery.order(Orders.asc(Hql.property("name")));
		agentQuery.join(Hql.innerJoin("plugins", "p"));
		agentQuery.restrict(Restrictions.eq(Hql.property("p", "pluginDefinition"), Hql.entity(plugin)));

		try
		{
			Plugin thePlugin = plugin.newInstance(Plugin.class, null, sc, null, null);
			requestedPermissions = thePlugin.getPermissions();
		}
		catch (BaseException ex)
		{
			warning = ex.getMessage();
		}
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Plugin" tab
		function validatePlugin()
		{
			var frm = document.forms['plugin'];
			if (Main.trimString(frm.className.value) == '')
			{
				alert("You must enter a class name");
				frm.className.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['plugin'];
			if (TabControl.validateActiveTab('settings'))
			{
				var agents = Link.getListIds(frm.agents, 'A');
				for (var i = 0; i < agents.length; i++)
				{
					var agentId = agents[i];
					var settings = getAgentSettings(agentId);
					if (settings)
					{
						if (!settings.useDefaultJarPath)
						{
							Forms.createHidden(frm, 'jarPath.'+agentId, settings.jarPath);
						}
						if (!settings.useDefaultMaxMemory)
						{
							Forms.createHidden(frm, 'maxMemory.'+agentId, settings.maxMemory);
						}
						if (!settings.useDefaultTrusted)
						{
							Forms.createHidden(frm, 'trusted.'+agentId, settings.trusted);
						}
						Forms.createHidden(frm, 'priorityBoost.'+agentId, settings.priorityBoost);
					}
				}
				
				frm.allAgents.value = agents.join(',');
				frm.removeAgents.value = Link.getActionIds(-1, 'A').join(',');
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
					annotationsLoaded = true;
				}
			}
		}
		
		function addAgentsOnClick()
		{
			var agents = Link.getListIds(document.forms['plugin'].agents, 'A');
			var url = '../jobagents/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAgentCallback';
			url += '&exclude='+agents.join(',');
			Main.openPopup(url, 'AddAgents', 1000, 700);
		}
		function addAgentCallback(agentId, name)
		{
			var item = Link.getItem('A', agentId);
			if (!item) 
			{
				item = new Item('A', agentId, name);
				new AgentSetting(agentId, '', '', '', '0');
			}
			var numBefore = document.forms['plugin'].agents.length;
			Link.addItem(document.forms['plugin'].agents, item);
			var numAfter = document.forms['plugin'].agents.length;
			if (numBefore == 0 && numAfter > 0)
			{
				document.forms['plugin'].use_internal_jobqueue.checked = false;
			}
			agentsOnClick();
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['plugin'].agents);
			Main.hide('agentsettings');
		}
		
		
		function init()
		{
			<%
			if (plugin == null)
			{
				%>
				var frm = document.forms['plugin'];
				frm.className.focus();
				frm.className.select();
				<%
			}
			%>
			initAgents();
			<%
			if (selectedAgentId != -1)
			{
				%>
				selectAgent(<%=selectedAgentId%>);
				<%
			}
			%>
			initPermissions();
		}
		function initAgents()
		{
			var agents = document.forms['plugin'].agents;
			Link.addNewSection(agents, new Section('A', 'Job agents'));
			<%
			if (agentQuery != null)
			{
				ItemResultList<JobAgent> agents = agentQuery.list(dc);
				for (JobAgent agent : agents)
				{
					// Agent specific settings
					JobAgentSettings settings = agent.getSettings(plugin, false);
					String jarPath = null;
					Boolean trusted = null;
					Long maxMemory = null;
					int priorityBoost = 0;
					if (settings != null)
					{
						jarPath = settings.getJarPath();
						trusted = settings.isTrusted();
						maxMemory = settings.getMaxMemory();
						priorityBoost = settings.getPriorityBoost();
						%>
						Link.addNewItem(agents, new Item('A', <%=agent.getId()%>, '<%=HTML.javaScriptEncode(agent.getName())%>'));
						<%
					}
					%>
					new AgentSetting(<%=agent.getId()%>, '<%=HTML.javaScriptEncode(jarPath)%>', '<%=trusted == null ? "" : trusted ? "1" : "0"%>', '<%=Values.formatBytes(maxMemory)%>', '<%=priorityBoost%>');
					<%
				}
			}
			%>
		}
		
		function selectAgent(agentId)
		{
			var frm = document.forms['plugin'];
			for (var i = 0; i < frm.agents.length; i++)
			{
				if (frm.agents[i].item.id == agentId)
				{
					frm.agents.selectedIndex = i;
					agentsOnClick();
					return;
				}
			}
		}

		function getAgentSettings(agentId)
		{
			return allAgentSettings['A'+agentId];
		}
		var allAgentSettings = new Array();
		function AgentSetting(agentId, jarPath, trusted, maxMemory, priorityBoost)
		{
			this.agentId = agentId;
			this.jarPath = jarPath;
			this.useDefaultJarPath = (jarPath == '');
			this.trusted = trusted;
			this.useDefaultTrusted = trusted != null;
			this.maxMemory = maxMemory;
			this.useDefaultMaxMemory = (maxMemory == '');
			this.priorityBoost = priorityBoost;
			allAgentSettings['A'+agentId] = this;
		}
		
		var selectedAgentId;
		function agentsOnClick()
		{
			var frm = document.forms['plugin'];
			var agentId = frm.agents[frm.agents.selectedIndex].item.id;
			var settings = getAgentSettings(agentId);
			if (settings)
			{
				Main.show('agentsettings');
				selectedAgentId = agentId;
				// Set JAR path
				frm.useDefaultJarPath.checked = settings.useDefaultJarPath;
				useDefaultJarPathOnClick();
				var defaultJarPath = document.getElementById("defaultJarPath");
				var html = frm.jarPath.value;
				if (html.length > 50)
				{
					html = '<span title="'+html+'">'+Main.cutString(html, 50)+'</span>';	
				}
				if (html == '') html = 'internal';
				defaultJarPath.innerHTML = html;
				
				// Set max memory
				frm.useDefaultMaxMemory.checked = settings.useDefaultMaxMemory;
				useDefaultMaxMemoryOnClick();
				var defaultMaxMemory = document.getElementById("defaultMaxMemory");
				defaultMaxMemory.innerHTML = frm.maxMemory.value == '' ? 'not specified' : frm.maxMemory.value;
				
				// Set trusted
				Forms.checkRadio(frm.agentTrusted, settings.trusted);
				var defaultTrusted = document.getElementById("defaultTrusted");
				defaultTrusted.innerHTML = Forms.getCheckedRadio(frm.trusted).value == '0' ? 'no' : 'yes';

				// Set priority boost
				frm.agentPriorityBoost.value = settings.priorityBoost;
			}
			else
			{
				Main.hide('agentsettings');
			}
		}
		
		function useDefaultJarPathOnClick()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				var useDefault = frm.useDefaultJarPath.checked;
				settings.useDefaultJarPath = useDefault;
				frm.agentJarPath.disabled = useDefault;
				if (!useDefault) 
				{
					frm.agentJarPath.focus();
					frm.agentJarPath.value = settings.jarPath;
				}
			}
		}
		
		function jarPathOnBlur()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				settings.jarPath = frm.agentJarPath.value;
			}
		}
		
		function useDefaultMaxMemoryOnClick()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				var useDefault = frm.useDefaultMaxMemory.checked;
				settings.useDefaultMaxMemory = useDefault;
				frm.agentMaxMemory.disabled = useDefault;
				if (!useDefault) 
				{
					frm.agentMaxMemory.focus();
					frm.agentMaxMemory.value = settings.maxMemory;
				}
			}
		}
		
		function maxMemoryOnBlur()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				settings.maxMemory = frm.agentMaxMemory.value;
			}
		}
		
		function trustedOnClick()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				var selected = Forms.getCheckedRadio(frm.agentTrusted);
				if (selected != null)
				{
					settings.trusted = selected.value;
					settings.useDefaultTrusted = settings.trusted == '';
				}
			}
		}
		
		function priorityBoostOnBlur()
		{
			var frm = document.forms['plugin'];
			var settings = getAgentSettings(selectedAgentId);
			if (settings)
			{
				var priorityBoost = parseInt(frm.agentPriorityBoost.value);
				if (priorityBoost < 0 || priorityBoost > 10)
				{
					alert('The priority boost must be between 0 and 10');
					frm.agentPriorityBoost.focus();
					return;
				}
				settings.priorityBoost = priorityBoost;
			}
		}
		
		function usePermissionsOnClick()
		{
			var frm = document.forms['plugin'];
			var use = Forms.getCheckedRadio(frm.use_permissions).value == '1';
			frm.items.disabled = !use;
			frm.grant_create.disabled = !use;
			frm.grant_read.disabled = !use;
			frm.grant_use.disabled = !use;
			frm.grant_write.disabled = !use;
			frm.grant_delete.disabled = !use;
			frm.grant_set_owner.disabled = !use;
			frm.grant_set_permission.disabled = !use;
			frm.deny_create.disabled = !use;
			frm.deny_read.disabled = !use;
			frm.deny_use.disabled = !use;
			frm.deny_write.disabled = !use;
			frm.deny_delete.disabled = !use;
			frm.deny_set_owner.disabled = !use;
			frm.deny_set_permission.disabled = !use;
		}
		
		function initPermissions()
		{
			var frm = document.forms['plugin'];
			for (var i = 0; i < frm.items.length; i++)
			{
				updateListText(i);
			}
			usePermissionsOnClick();
		}
		
		/*
			Update the permission code string for the list entry with given index
		*/
		function updateListText(index)
		{
			var frm = document.forms['plugin'];
			var item = frm.items[index];
			var itemType = item.value;
			if (itemType)
			{
				var granted = parseInt(frm[itemType+'_granted'].value);
				var denied = parseInt(frm[itemType+'_denied'].value);
				var defined = parseInt(frm[itemType+'_defined'].value);
				
				var s = '';
				s += appendPermission('C', granted, denied, defined, <%=CREATE_CODE%>);
				s += appendPermission('R', granted, denied, defined, <%=READ_CODE%>);
				s += appendPermission('U', granted, denied, defined, <%=USE_CODE%>);
				s += appendPermission('W', granted, denied, defined, <%=WRITE_CODE%>);
				s += appendPermission('D', granted, denied, defined, <%=DELETE_CODE%>);
				s += appendPermission('O', granted, denied, defined, <%=SET_OWNER_CODE%>);
				s += appendPermission('P', granted, denied, defined, <%=SET_PERMISSION_CODE%>);
				
				var text = item.text.replace(/\[.*\]/, '['+s+']');
				item.text = text; 
			}
		}
		
		function appendPermission(cc, granted, denied, defined, permission)
		{
			var p = '';
			if ((defined & permission) > 0)
			{
				p = (granted & permission) > 0 ? cc.toUpperCase() : ((denied & permission) > 0 ? '-' : cc.toLowerCase());
			}
			return p;
		}
		
		function itemsOnClick()
		{
			var frm = document.forms['plugin'];
			var itemType = frm.items[frm.items.selectedIndex].value;
			if (itemType)
			{
				showPermissions(itemType);
			}
		}
		
		/*
			Update checkboxes to show the permissions for specified item type
		*/
		function showPermissions(itemType)
		{
			var frm = document.forms['plugin'];
			if (itemType)
			{
				var granted = parseInt(frm[itemType+'_granted'].value);
				var denied = parseInt(frm[itemType+'_denied'].value);
				var defined = parseInt(frm[itemType+'_defined'].value);
				
				updateCheckBox('create', <%=CREATE_CODE%>, granted, denied, defined);
				updateCheckBox('read', <%=READ_CODE%>, granted, denied, defined);
				updateCheckBox('use', <%=USE_CODE%>, granted, denied, defined);
				updateCheckBox('write', <%=WRITE_CODE%>, granted, denied, defined);
				updateCheckBox('delete', <%=DELETE_CODE%>, granted, denied, defined);
				updateCheckBox('set_owner', <%=SET_OWNER_CODE%>, granted, denied, defined);
				updateCheckBox('set_permission', <%=SET_PERMISSION_CODE%>, granted, denied, defined);
			}
		}
		
		/*
			Check/uncheck and enable/disable checkboxes depending on given permissions
		*/
		function updateCheckBox(nameSuffix, permission, granted, denied, defined)
		{
			var frm = document.forms['plugin'];
			var isGranted = (permission & granted) > 0;
			var isDenied = (permission & denied) > 0;
			var isDefined = (permission & defined) > 0;
			
			frm['grant_'+nameSuffix].disabled = !isDefined;
			frm['deny_'+nameSuffix].disabled = !isDefined || isGranted;
			frm['grant_'+nameSuffix].checked = isGranted & isDefined;
			frm['deny_'+nameSuffix].checked = isDenied & isDefined;
		}
		
		
		// When a user clicks on one of the permission checkboxes
		function permissionOnClick(checkbox)
		{
			var frm = document.forms['plugin'];
			cascadeSelections(checkbox.checked);
			var granted = getCheckedPermissions('grant_');
			var denied = getCheckedPermissions('deny_');
			for (var i = 0; i < frm.items.length; i++)
			{
				var item = frm.items[i];
				var itemType = item.value;
				if (item.selected && itemType)
				{
					frm[itemType+'_granted'].value = granted;
					frm[itemType+'_denied'].value = denied;
					updateListText(i);
				}
			}
		}
		
		/*
			Get the permission for the checked checkboxes
			prefix should be "grant_" or "deny_"
		*/
		function getCheckedPermissions(prefix)
		{
			var permissionCode = 0;
			var frm = document.forms['plugin'];
			permissionCode += frm[prefix+'create'].checked ? <%=CREATE_CODE%>: 0;
			permissionCode += frm[prefix+'read'].checked ? <%=READ_CODE%>: 0;
			permissionCode += frm[prefix+'use'].checked ? <%=USE_CODE%>: 0;
			permissionCode += frm[prefix+'write'].checked ? <%=WRITE_CODE%>: 0;
			permissionCode += frm[prefix+'delete'].checked ? <%=DELETE_CODE%>: 0;
			permissionCode += frm[prefix+'set_owner'].checked ? <%=SET_OWNER_CODE%>: 0;
			permissionCode += frm[prefix+'set_permission'].checked ? <%=SET_PERMISSION_CODE%>: 0;
			return permissionCode;
		}
		/*
			Makes sure all checkboxes are in a consistent state with
			each other.
		*/
		function cascadeSelections(checked)
		{
			var frm = document.forms['plugin'];
			
			// Grant permissions
			if (checked)
			{
				frm['grant_write'].checked = (frm['grant_write'].checked || frm['grant_delete'].checked || frm['grant_set_owner'].checked || frm['grant_set_permission'].checked);
				frm['grant_use'].checked = (frm['grant_use'].checked || frm['grant_write'].checked);
				frm['grant_read'].checked = (frm['grant_read'].checked || frm['grant_use'].checked);
			}
			else
			{
				frm['grant_use'].checked = (frm['grant_use'].checked && frm['grant_read'].checked);
				frm['grant_write'].checked = (frm['grant_write'].checked && frm['grant_use'].checked);
				frm['grant_delete'].checked = (frm['grant_delete'].checked && frm['grant_write'].checked);
				frm['grant_set_owner'].checked = (frm['grant_set_owner'].checked && frm['grant_write'].checked);
				frm['grant_set_permission'].checked = (frm['grant_set_permission'].checked && frm['grant_write'].checked);
			}
			
			// Deny permissions
			frm['deny_create'].disabled = frm['grant_create'].disabled || frm['grant_create'].checked;
			frm['deny_read'].disabled =frm['grant_read'].disabled || frm['grant_read'].checked;
			frm['deny_use'].disabled = frm['grant_use'].disabled || frm['grant_use'].checked;
			frm['deny_write'].disabled = frm['grant_write'].disabled || frm['grant_write'].checked;
			frm['deny_delete'].disabled = frm['grant_delete'].disabled || frm['grant_delete'].checked;
			frm['deny_set_owner'].disabled = frm['grant_set_owner'].disabled || frm['grant_set_owner'].checked;
			frm['deny_set_permission'].disabled = frm['grant_set_permission'].disabled || frm['grant_set_permission'].checked;
			if (checked)
			{
				if (!frm['deny_use'].disabled) frm['deny_use'].checked = frm['deny_use'].checked || frm['deny_read'].checked;
				if (!frm['deny_write'].disabled) frm['deny_write'].checked = frm['deny_write'].checked || frm['deny_use'].checked;
				if (!frm['deny_delete'].disabled) frm['deny_delete'].checked = frm['deny_delete'].checked || frm['deny_write'].checked;
				if (!frm['deny_set_owner'].disabled) frm['deny_set_owner'].checked = frm['deny_set_owner'].checked || frm['deny_write'].checked;
				if (!frm['deny_set_permission'].disabled) frm['deny_set_permission'].checked = frm['deny_set_permission'].checked || frm['deny_write'].checked;
			}
			else
			{
				if (!frm['deny_write'].disabled) frm['deny_write'].checked = frm['deny_write'].checked && !((!frm['deny_delete'].checked && !frm['deny_delete'].disabled) || (!frm['deny_set_owner'].checked && !frm['deny_set_owner'].disabled) || (!frm['deny_set_permission'].checked && !frm['deny_set_permission'].disabled));
				if (!frm['deny_use'].disabled) frm['deny_use'].checked = frm['deny_use'].checked && frm['deny_write'].checked;
				if (!frm['deny_read'].disabled) frm['deny_read'].checked = frm['deny_read'].checked && frm['deny_use'].checked;
			}
		}
		<%
		if (requestedPermissions != null && requestedPermissions.size() > 0)
		{
			%>
			function setRequestedPermissions()
			{
				var frm = document.forms['plugin'];
				// Reset all existing permissions
				for (var i = 0; i < frm.items.length; i++)
				{
					var itemType = frm.items[i].value;
					if (itemType)
					{
						frm[itemType+'_granted'].value = 0;
						frm[itemType+'_denied'].value = 255;
					}
				}
				// Set requested permissions
				<%
				for (Permissions pp : requestedPermissions)
				{
					Item ppType = pp.getItemType();
					if (ppType.getDefinedPermissions() != null)
					{
						Set<Permission> always = Permission.expand(pp.getAlwaysGranted());
						Set<Permission> maybe = Permission.expand(pp.getMaybeGranted());
						%>
						frm['<%=ppType.name()%>_granted'].value = <%=always == null ? 0 : PermissionUtil.getPermissionCode(always)%>;
						frm['<%=ppType.name()%>_denied'].value = <%=maybe == null ? 255 : 255 & ~PermissionUtil.getPermissionCode(maybe)%>;
						<%
					}
				}
				%>
				// Update the list
				initPermissions();
			}
			<%
		}
		%>
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="plugin" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" remember="<%=plugin != null%>" 
			active="<%=selectedAgentId == -1 ? null : "agents" %>" switch="switchTab">
		<t:tab id="info" title="Plugin" validate="validatePlugin()" helpid="plugindefinition.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(plugin == null ? Values.getString(cc.getPropertyValue("name"), "New plugin") : plugin.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Class</td>
				<td><input <%=requiredClazz%> type="text" name="className" 
					value="<%=HTML.encodeTags(plugin == null ? cc.getPropertyValue("className") : plugin.getClassName())%>" 
					size="50" maxlength="<%=PluginDefinition.MAX_CLASSNAME_LENGTH%>"></td>
			</tr>
			
			<tr>
				<td class="prompt">Path</td>
				<td><input <%=clazz%> type="text" name="jarPath" 
					value="<%=HTML.encodeTags(plugin == null ? cc.getPropertyValue("jarPath") : plugin.getJarPath())%>"
					size="50" maxlength="<%=PluginDefinition.MAX_JARPATH_LENGTH%>">
				</td>
			</tr>
			<tr>
				<td class="prompt">Max memory</td>
				<td><input <%=clazz%> type="text" name="maxMemory" 
					value="<%=Values.formatBytes(plugin == null ? Values.parseBytes(cc.getPropertyValue("maxMemory"), null) : plugin.getMaxMemory())%>"
					size="16" maxlength="16"> (Use KB, MB or GB to specify units)</td>
			</tr>
			
			<tr>
				<td class="prompt">Trusted</td>
				<td>
					<input type="radio" name="trusted" value="0" <%=!isTrusted ? "checked" : ""%>>no
					<input type="radio" name="trusted" value="1" <%=isTrusted ? "checked" : ""%>>yes
				</td>
			</tr>	
			
			<tr>
				<td class="prompt">Allow immediate exection</td>
				<td>
					<input type="radio" name="allow_immediate_execution" value="0" 
						<%=Boolean.FALSE.equals(allowImmediateExecution) ? "checked" : ""%>>no
					<input type="radio" name="allow_immediate_execution" value="1" 
						<%=Boolean.TRUE.equals(allowImmediateExecution) ? "checked" : ""%>>yes
					<%
					if (allowImmediateExecution == null)
					{
						%>
						<input type="radio" name="allow_immediate_execution" value="" 
							"checked">auto
						<%
					}
					%>
				</td>
			</tr>	
			</table>
			<%
			if (warning != null) 
			{
				%>
				<div class="error"><%=warning%></div>
				<%
			}
			%>			
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="permissions" title="Permissions" 
			tooltip="Set permissions for this plugindefintion" helpid="plugindefinition.edit.permissions">
		<table class="form">
			<tr>	
				<td class="prompt">Use permissions</td>
				<td>
					<input type="radio" name="use_permissions" value="1" 
						<%=usePermissions ? "checked" : ""%> onclick="usePermissionsOnClick()">yes
					<input type="radio" name="use_permissions" value="0" 
						<%=!usePermissions ? "checked" : ""%> onclick="usePermissionsOnClick()">no
					<%
					if (plugin == null)
					{
						%>
						<input type="radio" name="use_permissions" value="2" 
							onclick="usePermissionsOnClick()">if requested by plugin
						<%
					}
					%>
				</td>
			</tr>
		</table>

		<table>
		<tr valign="top">
		<td>
			<b>Item types</b><br>
			<select name="items" size="14" onChange="itemsOnClick()" multiple>
			<%
			Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
			for (Map.Entry<String, List<Item>> entry : permissionGroups.entrySet())
			{
				String name = entry.getKey();
				List<Item> items = entry.getValue();
				%>
				<option class="selectoptionheader" value="">-- <%=name%>
				<%
				for (Item item : items)
				{
					%>
					<%=getOption(dc, plugin, item)%>
					<%
				}
			}
			%>
			</select>
		</td>
		<td>
			<table>
			<tr valign="top"><td>
				<b>Always grant</b><br>
				<input type="checkbox" name="grant_create" onClick="permissionOnClick(this)">Create<br>
				<input type="checkbox" name="grant_read" onClick="permissionOnClick(this)">Read<br>
				<input type="checkbox" name="grant_use" onClick="permissionOnClick(this)">Use<br>
				<input type="checkbox" name="grant_write" onClick="permissionOnClick(this)">Write<br>
				<input type="checkbox" name="grant_delete" onClick="permissionOnClick(this)">Delete<br>
				<input type="checkbox" name="grant_set_owner" onClick="permissionOnClick(this)">Set owner<br>
				<input type="checkbox" name="grant_set_permission" onClick="permissionOnClick(this)">Set permission
			</td>
			<td>
				<b>Always deny</b><br>
				<input type="checkbox" name="deny_create" onClick="permissionOnClick(this)">Create<br>
				<input type="checkbox" name="deny_read" onClick="permissionOnClick(this)">Read<br>
				<input type="checkbox" name="deny_use" onClick="permissionOnClick(this)">Use<br>
				<input type="checkbox" name="deny_write" onClick="permissionOnClick(this)">Write<br>
				<input type="checkbox" name="deny_delete" onClick="permissionOnClick(this)">Delete<br>
				<input type="checkbox" name="deny_set_owner" onClick="permissionOnClick(this)">Set owner<br>
				<input type="checkbox" name="deny_set_permission" onClick="permissionOnClick(this)">Set permission
			</td>
			<%
			if (requestedPermissions != null && requestedPermissions.size() > 0)
			{
				%>
				<td>
				<b>Requested by plugin</b><br>
				<table>
				<%
				for (Permissions pp : requestedPermissions)
				{
					Item ppType = pp.getItemType();
					Set<Permission> always = Permission.expand(pp.getAlwaysGranted());
					Set<Permission> maybe = Permission.expand(pp.getMaybeGranted());
					Set<Permission> defined = ppType.getDefinedPermissions();
					if (defined != null)
					{
						StringBuilder sb = new StringBuilder();
						sb.append("[");
						appendPermissionLetter(sb, Permission.CREATE, "C", defined, always, maybe);
						appendPermissionLetter(sb, Permission.READ, "R", defined, always, maybe);
						appendPermissionLetter(sb, Permission.USE, "U", defined, always, maybe);
						appendPermissionLetter(sb, Permission.WRITE, "W", defined, always, maybe);
						appendPermissionLetter(sb, Permission.DELETE, "D", defined, always, maybe);
						appendPermissionLetter(sb, Permission.SET_OWNER, "O", defined, always, maybe);
						appendPermissionLetter(sb, Permission.SET_PERMISSION, "P", defined, always, maybe);
						sb.append("]");
						%>
						<tr>
							<td><%=ppType%></td>
							<td><%=sb.toString()%></td>
						</tr>
						<%
					}
				}
				%>
				</table>
				<table><tr><td>
				<base:button title="Use requested permissions" onclick="setRequestedPermissions()"
					tooltip="Use the permissions requested by the plugin." />
				</td></tr></table>
				</td>
				<%
			}
			%>
			</tr>
			</table>
			<b>Capital letters</b> = Permission is always granted<br>
			<b>Small letters</b> = Permission is only granted if logged in user 
				has that permission
			
		</td>
		</tr>
		</table>
		
		
		</t:tab>
		
		
		<t:tab id="agents" title="Job agents" helpid="plugindefinition.jobagents">
			<table class="form">
			<tr valign="top">
			<td class="prompt">Run this plugin on</td>
			<td>
				<input type="checkbox" name="use_internal_jobqueue" value="1"
					<%=plugin == null || plugin.getUseInternalJobQueue() ? "checked" : "" %>>
					internal job queue
			</td>
			</tr>
			<tr>
			<td>
				<select name="agents" size="12" multiple style="width: 15em;" 
					onclick="agentsOnClick()">
				</select>
				<input type="hidden" name="removeAgents" value="">
				<input type="hidden" name="allAgents" value="">
			</td>
			<td>
				<table width="150">
				<tr><td><base:button 
					onclick="addAgentsOnClick()" 
					title="Add&nbsp;job&nbsp;agents&hellip;"  
					tooltip="Add job agents to this plugin"
				/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the selected job agents"
				/></td></tr>
				</table>

				<br>
				<div id="agentsettings" style="display: none;">
				<b>Settings for the selected job agent</b>
				<table border="0" cellspacing="0" class="form">
				<tr>
					<td class="prompt">Jar path</td>
					<td>
						<input type="text" name="agentJarPath" class="text" size="50" 
							maxlength="<%=JobAgentSettings.MAX_JARPATH_LENGTH%>"
							onblur="jarPathOnBlur()">
					</td>
				</tr>
				<tr>
					<td style="padding-left: 10px;">-use default</td>
					<td>
						<input type="checkbox" name="useDefaultJarPath"
							onclick="useDefaultJarPathOnClick()">
						(<span id="defaultJarPath"></span>)
					</td>
				</tr>
				<tr>
					<td class="prompt">Max memory</td>
					<td>
						<input type="text" name="agentMaxMemory" class="text" size="16" 
							maxlength="16"
							onblur="maxMemoryOnBlur()">
							(Use KB, MB or GB to specify memory)
					</td>
				</tr>
				<tr>
					<td style="padding-left: 10px;">-use default</td>
					<td>
						<input type="checkbox" name="useDefaultMaxMemory"
							onclick="useDefaultMaxMemoryOnClick()">
						(<span id="defaultMaxMemory"></span>)
					</td>
				</tr>
				<tr>
					<td class="prompt">Trusted</td>
					<td>
						<input type="radio" name="agentTrusted" value="" 
							onclick="trustedOnClick()">default (<span id="defaultTrusted"></span>)
						<input type="radio" name="agentTrusted" value="1"
							onclick="trustedOnClick()">yes
						<input type="radio" name="agentTrusted" value="0"
							onclick="trustedOnClick()">no
					</td>
				</tr>
				<tr>
					<td class="prompt">Priority boost</td>
					<td>
						<input type="text" name="agentPriorityBoost" class="text" size="12" 
							maxlength="10" onkeypress="return Numbers.integerOnly(event)"
							onblur="priorityBoostOnBlur()">
					</td>
				</tr>
				</table>
				</div>
			</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			helpid="annotations.edit" tooltip="Enter values for annotations"
			visible="<%=plugin != null && !plugin.requiresConfiguration() && plugin.supports("net.sf.basedb.core.plugin.AnnotationSetterPlugin")%>">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		<%
		ItemResultList<RoleKey> roleKeys = roleKeyQuery.list(dc);
		for (RoleKey key : roleKeys)
		{
			int grantedCode = plugin == null ? 0 : PermissionUtil.getPermissionCode(plugin.getGranted(key));
			int deniedCode = plugin == null ? 255 : PermissionUtil.getPermissionCode(plugin.getDenied(key));
			int definedCode = key.getItemType().getDefinedPermissions() == null ? 0 : PermissionUtil.getPermissionCode(key.getItemType().getDefinedPermissions());			
			String name = key.getItemType().name();						
			%>
			<input type="hidden" name="<%=name%>_granted" value="<%=grantedCode%>">
			<input type="hidden" name="<%=name%>_denied" value="<%=deniedCode%>">
			<input type="hidden" name="<%=name%>_defined" value="<%=definedCode%>">
			<%
		}
		%>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
