<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.InvalidDataException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.AjaxWriter"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.io.OutputStreamWriter"
	import="java.io.Writer"
	import="java.io.Reader"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
AjaxWriter aw = new AjaxWriter(out);
try
{
	if ("WellInfo".equals(cmd))
	{
		dc = sc.newDbControl();
		boolean encodeStrings = Values.getBoolean(request.getParameter("encodeStrings"));
		BioWell w = BioWell.getById(dc, itemId);
		boolean isEmpty = w.isEmpty();
		boolean hasBeenUsed = w.hasBeenUsed();
		String status = "Ok";
		MeasuredBioMaterial bm = null;
		if (isEmpty && !hasBeenUsed)
		{
			status = "Empty";
		}
		else
		{
			try
			{
				bm = isEmpty ? w.getOriginalBioMaterial() : w.getBioMaterial();
			}
			catch (PermissionDeniedException ex)
			{
				status = "Denied";
				bm = null;
			}
		}
		aw.ajaxPrintEntry("id", w.getId());
		aw.ajaxPrintEntry("status", status);		
		if (bm != null)
		{
			aw.ajaxPrintEntry("bm.id", bm.getId());
			aw.ajaxPrintEntry("bm.type", bm.getType().name());
			aw.ajaxPrintEntry("bm.editable", bm.hasPermission(Permission.WRITE) ? "1" : "0");
			aw.ajaxPrintEntry("bm.name", encodeStrings ? HTML.encodeTags(bm.getName()) : bm.getName());
			aw.ajaxPrintEntry("bm.description", encodeStrings ? HTML.niceFormat(bm.getDescription()) : bm.getDescription());
		}
		aw.ajaxEndRecord();
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	aw.ajaxPrintEntry("status", "error");
	aw.ajaxPrintEntry("message", t.getMessage());
	aw.ajaxPrintEntry("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	if (dc != null) dc.close();
	aw.flush();
}
%>