<%-- $Id: ajax.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.AjaxWriter"
	import="java.util.List"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
AjaxWriter aw = new AjaxWriter(out);
try
{
	if ("GetSubdirectories".equals(cmd))
	{
		dc = sc.newDbControl();
		Directory dir = Directory.getById(dc, itemId);
		
		ItemQuery<Directory> query = dir.getSubDirectories();
		query.include(Include.ALL);
		query.order(Orders.asc(Hql.property("name")));
		List<Directory> subdirs = query.list(dc);
		aw.ajaxPrintEntry("status", "ok");
		for (Directory d : subdirs)
		{
			aw.ajaxPrintEntry("id", d.getId());
			aw.ajaxPrintEntry("name", d.getName());
			aw.ajaxPrintEntry("path", d.getPath());
			aw.ajaxPrintEntry("removed", d.isRemoved() ? "1" : "0");
			aw.ajaxPrintEntry("auto-compress", d.getAutoCompress() ? "1" : "0");
			aw.ajaxPrintEntry("home", d.isHomeDirectory() ? "1" : "0");
			aw.ajaxEndRecord();
		}
		dc.commit();
	}
	else
	{
		throw new RuntimeException("Invalid command. The command " + cmd + " is not recognised as a valid command.");
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	aw.ajaxPrintEntry("status", "error");
	aw.ajaxPrintEntry("message", t.getMessage());
	aw.ajaxPrintEntry("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	if (dc != null) dc.close();
	aw.flush();
}
//out.flush();
//out.close();
%>