<%-- $Id: edit_file_data.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	final File file = File.getById(dc, itemId);
	final String mimeType = file.getMimeType();
	final boolean editable = file.hasPermission(Permission.WRITE) && !file.isWriteProtected() &&
		mimeType != null &&  mimeType.startsWith("text/") && 
		file.getSize() < 102400 && file.getLocation() == Location.PRIMARY;

	if (!editable)
	{
		throw new PermissionDeniedException(Permission.WRITE, "Online editing of file is not allowed: " + file);
	}
	final String path = file.getPath().toString();
	final String title = "Edit file -- " + HTML.encodeTags(file.getName());
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="ajax.js" styles="toolbar.css">
		<script language="JavaScript">
		var timer = 0;
		var inCall = false;
		var isModified = false;
		var originalText;
		function adjustTextareaSize()
		{
			if (inCall) return;
			inCall = true;
			var textareaElement = document.getElementById("filedata");
			var lineNumberElement = document.getElementById("linenumbers");
			// Find the top coordinate of the textarea
			var offsetTop = 1;
			var offsetTrail = textareaElement;
			while (offsetTrail)
			{
				offsetTop += offsetTrail.offsetTop;
				offsetTrail = offsetTrail.offsetParent;
			}
			// Find the browser window height
			var windowHeight = Main.getWindowHeight();
			textareaElement.style.height = (windowHeight-offsetTop - 50) + 'px';
			lineNumberElement.style.height = (windowHeight-offsetTop - 50) + 'px';
			inCall = false;
		}
		function setTimer()
		{
			if (inCall) return;
			if (timer) clearTimeout(timer);
			timer = setTimeout('adjustTextareaSize()', 150);
		}
		function init()
		{
			downloadFile();
			adjustTextareaSize();
		}
		function downloadFile()
		{
			var url = 'download/-<%=ID%>-/<%=HTML.javaScriptEncode(path)%>';
			var request = Main.getAjaxRequest();
			request.open("GET", url, true);
			Ajax.setReadyStateHandler(request, onFileLoaded);
			request.send(null);
		}
		function onFileLoaded(request)
		{
			var frm = document.forms['file'];
			frm.filedata.value = request.responseText;
			originalText = frm.filedata.value;
			setModified(false);
			updateLineNumbers();
		}
		function saveFile(closeIfSuccess)
		{
			if (!isModified) return;
			var frm = document.forms['file'];
			var url = 'ajax.jsp?ID=<%=ID%>&cmd=StoreFile&item_id=<%=itemId%>';
			url += '&size='+frm.filedata.value.length;
			var request = Main.getAjaxRequest();
			request.closeIfSuccess = closeIfSuccess;
			request.open("POST", url, true);
			Ajax.setReadyStateHandler(request, onFileStored);
			request.send(frm.filedata.value);
		}
		function onFileStored(request)
		{
			var response = request.responseText;
			var failed = response.indexOf('Save failed') == 0;
			if (!failed) 
			{
				setModified(false);
			}
			alert(response);
			if (request.closeIfSuccess && !failed) 
			{
				closeWindow(true);
				return;
			}
		}
		function closeFile(autoSave)
		{
			if (isModified)
			{
				if (autoSave || confirm('The file has been modified. Save changes?'))
				{
					saveFile(true);
					return;
				}
			}
			closeWindow(false);
		}
		function closeWindow(refreshParent)
		{
			if (refreshParent)
			{
				location.href = getRoot() + 'common/close_popup.jsp?refresh_opener=1&wait=0';
			}
			else
			{
				window.close();
			}
		}
		
		function detectChanges()
		{
			if (!isModified)
			{
				var frm = document.forms['file'];
				if (frm.filedata.value != originalText) setModified(true);
			}
		}
		function setModified(modified)
		{
			isModified = modified;
		}
		function detectTab(event)
		{
			var key = Main.getEventCharCode(event);
			if (key == 9)
			{
				var frm = document.forms['file'];
				replaceSelection(frm.filedata, '\t');
				return false;
			}
			return true;
		}

		function updateLineNumbers()
		{
			var frm = document.forms['file'];
			var totalScroll = frm.filedata.scrollHeight;
			var topScroll = frm.filedata.scrollTop;
			var textHeight = frm.filedata.offsetHeight;
			var topLine = 1;
			if (totalScroll > textHeight || topScroll > 0)
			{
				var numLines = frm.filedata.value.split('\n').length;
				var scrollPerLine = Math.round(totalScroll / numLines);
				var visibleLines = Math.ceil(frm.filedata.offsetHeight / scrollPerLine)
				topLine = 1 + Math.round(topScroll / scrollPerLine);
				frm.filedata.scrollTop = scrollPerLine * (topLine - 1);
			}
			var lineNumberHTML = '';
			for (var i = topLine; i < topLine + 100; i++)
			{
				lineNumberHTML += i + '<br>';
			}
			var lineNumberElem = document.getElementById('linenumbers');
			lineNumberElem.innerHTML = lineNumberHTML;
		}
		
		/*
			Replace the selected text with the given text. Code based on
			Trac: http://projects.edgewall.com/trac/
		*/
		function replaceSelection(field, text)
		{
			field.focus();
		    var start, end, sel, scrollPos;
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      sel = document.selection.createRange().text;
		    } 
		    else if (typeof(field["setSelectionRange"]) != "undefined") 
		    {
		      start = field.selectionStart;
		      end = field.selectionEnd;
		      scrollPos = field.scrollTop;
		      sel = field.value.substring(start, end);
		    }
		    if (sel.match(/ $/)) 
		    { 
		    	// exclude ending space char, if any
		      	sel = sel.substring(0, sel.length - 1);
		    }
		    if (typeof(document["selection"]) != "undefined") 
		    {
		      var range = document.selection.createRange().text = text;
		    } 
		    else if (typeof(field["setSelectionRange"]) != "undefined") 
		    {
		    	field.value = field.value.substring(0, start) + text +
		      		field.value.substring(end);
		      field.setSelectionRange(start + text.length, start + text.length);
		      field.scrollTop = scrollPos;
		    }
		}
		</script>
		<style>
		.linenumbers {
			width: 36px;
			text-align: right;
			overflow: hidden;
			color: #333399;
			background: #e0e0e0;
			xborder: 1px solid #999999;
			border-top: 2px groove #999999;
			border-left: 2px groove #999999;
			border-bottom: 2px ridge #FFFFFF;
			border-right: 0px;
			padding-right: 4px;
			font-family: monospace;
		}
		</style>
	</base:head>
	<base:body onload="init()" attributes="onresize='setTimer();'">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="file" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help helpid="file.edit.data" /></h3>
		<table width="100%" border="0" cellspacing="0" cellpadding="0">
		<tr>
		<td><div id="linenumbers" class="linenumbers"></div></td>
		<td width="100%" style="padding-right: 4px;">
			<textarea id="filedata" name="filedata" style="width: 100%;"
				wrap="off"
				onkeydown="return detectTab(event);"
				onkeyup="detectChanges()"
				onscroll="updateLineNumbers()"
				>Loading file; please wait...</textarea>
		</td>
		</tr>
		</table>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="closeFile(true)" title="Save" /></td>
			<td width="50%"><base:button onclick="closeFile(false)" title="Close" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
