<%-- $Id: list_files.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemContext.SortDirection"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Iterator"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FILE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final String subcontext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, null, null);

final int directoryId = Values.getInt(request.getParameter("directory_id"), SystemItems.getId(Directory.ROOT));
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = null; //mode.generateTitle("file", "files");
final boolean isSearch = "search".equals(subcontext);
final boolean hasFilter = cc.getNumPropertyFilters() > 0;
final DbControl dc = sc.newDbControl();
ItemResultIterator<File> files = null;
ItemResultIterator<Directory> directories = null;
try
{
	final Directory current = isSearch ? null : Directory.getById(dc, directoryId);
	final boolean createFilePermission = isSearch ? false : sc.hasPermission(Permission.CREATE, itemType) && current.hasPermission(Permission.USE);
	final boolean createDirectoryPermission = isSearch ? false : sc.hasPermission(Permission.CREATE, Item.DIRECTORY) && current.hasPermission(Permission.USE);

	Unit bytes = UnitUtil.getUnit(dc, Quantity.STORAGE_SIZE, "B");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	// Get all file types
	final ItemQuery<FileType> typeQuery = FileType.getQuery();
	typeQuery.order(Orders.asc(Hql.property("name")));
	typeQuery.setCacheResult(true);

	// Create directory query
	final ItemQuery<Directory> directoryQuery = Directory.getQuery();
	directoryQuery.include(cc.getInclude());
	if (!isSearch) 
	{
		// Limit to current directory; no paging
		directoryQuery.restrict(Restrictions.eq(Hql.property("parent"), Hql.entity(current)));
		directoryQuery.setFirstResult(0);
		directoryQuery.setMaxResults(-1);
		directoryQuery.setReturnTotalCount(false);
	}
	else
	{
		// Never match the root directory; setup paging
		directoryQuery.restrict(Restrictions.neq(Hql.property("parent"), null));
		directoryQuery.setFirstResult(cc.getPage() * cc.getRowsPerPage());
		directoryQuery.setMaxResults(cc.getRowsPerPage());
		directoryQuery.setReturnTotalCount(false);
	}
	boolean hasDirFilter = false;
	// Add 'name', 'description' and other common filters to directory query
	PropertyFilter filter = cc.getPropertyFilter("name");
	if (filter != null) 
	{
		directoryQuery.restrict(filter.getRestriction(dc, directoryQuery));
		hasDirFilter = true;
	}
	filter = cc.getPropertyFilter("description");
	if (filter != null) 
	{
		directoryQuery.restrict(filter.getRestriction(dc, directoryQuery));
		hasDirFilter = true;
	}
	filter = cc.getPropertyFilter("compressed");
	if (filter != null)
	{
		directoryQuery.restrict(Restrictions.eq(Hql.property("autoCompress"), Expressions.parameter("autoCompress")));
		directoryQuery.setParameter("autoCompress", filter.getValueAsObject(), Type.BOOLEAN);
		hasDirFilter = true;
	}
	filter = cc.getPropertyFilter("!sharedTo.name");
	if (filter != null) 
	{
		directoryQuery.restrict(filter.getRestriction(dc, directoryQuery));
		hasDirFilter = true;
	}
	filter = cc.getPropertyFilter("directory.name");
	if (filter != null)
	{
		filter = new PropertyFilter("parent.name", filter.getOperator(), filter.getValue(), filter.getValueType());
		directoryQuery.restrict(filter.getRestriction(dc, directoryQuery));
		hasDirFilter = true;
	}
	filter = cc.getPropertyFilter("owner.name");
	if (filter != null)
	{
		directoryQuery.restrict(filter.getRestriction(dc, directoryQuery));
		hasDirFilter = true;
	}
	if (cc.getItemPermission() != null) directoryQuery.setItemPermission(cc.getItemPermission());
	
	// Add sort order to directory query
	String sortProperties = cc.getSortProperty();
	boolean sorted = false;
	if (sortProperties != null)
	{
		String[] tmp = sortProperties.split(",");
		SortDirection sortDirection = cc.getSortDirection();
		for (String sort : tmp)
		{
			if ("name".equals(sort) || "description".equals(sort) || "owner.name".equals(sort))
			{
				directoryQuery.order(sortDirection.sortBy(Hql.property(sort)));
				sorted = true;
			}
			else if ("directory.name".equals(sort))
			{
				directoryQuery.order(sortDirection.sortBy(Hql.property("parent.name")));
				sorted = true;
			}
		}
	}
	if (!sorted)
	{
		directoryQuery.order(Orders.asc(Hql.property("name")));
	}
	
	int numDirectories = isSearch && hasDirFilter ? (int)directoryQuery.count(dc) : 0;
	int maxFiles = cc.getRowsPerPage();
	
	// Get all files in current directory
	final ItemQuery<File> fileQuery = Base.getConfiguredQuery(cc, true, File.getQuery(), mode);
	if (!isSearch) 
	{
		fileQuery.restrict(Restrictions.eq(Hql.property("directory"), Hql.entity(current)));
		fileQuery.setFirstResult(0);
		fileQuery.setMaxResults(-1);
		fileQuery.setReturnTotalCount(false);
	}
	else
	{
		int firstFile = cc.getPage() * cc.getRowsPerPage() - numDirectories;
		if (firstFile < 0) 
		{
			maxFiles += firstFile;
			firstFile = 0;
			if (maxFiles < 0) maxFiles = 0;
		}
		fileQuery.setFirstResult(firstFile);
		fileQuery.setMaxResults(maxFiles);
		fileQuery.setReturnTotalCount(false);
	}

	int numFiles = isSearch && hasFilter ? (int)fileQuery.count(dc) : 0;
	try
	{
		files = !isSearch || hasFilter && maxFiles > 0 ? fileQuery.iterate(dc) : null;
		directories = !isSearch || hasDirFilter ? directoryQuery.iterate(dc) : null;
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	
	int numListed = 0;
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	int numDecimals = FormatterSettings.getNumDecimals(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, current);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title==null ? "Files" : title%>" type="popup">
	<base:head scripts="table.js,menu.js" styles="table.css,menu.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'files';
		function editFile(fileId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', fileId, true);
		}
		function uploadFile(fileId)
		{
			var cmd = fileId ? 'UploadFile' : 'UploadNewFile';
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&directory_id=<%=directoryId%>&item_id='+fileId, 'UploadFile', 680, 520);
		}
		function viewFile(fileId)
		{
			location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id='+fileId;
		}
		function fileOnClick(evt, fileId)
		{
			Table.itemOnClick(formId, evt, fileId, '<%=mode.getName()%>', viewFile, editFile, returnSelected);
		}
		
		function editDirectory(directoryId)
		{
			Main.viewOrEditItem('<%=ID%>', 'DIRECTORY', directoryId, true);
		}
		function directoryOnClick(evt, directoryId)
		{
			editDirectory(directoryId);
		}
		function newDirectory()
		{
			Main.viewOrEditItem('<%=ID%>', 'DIRECTORY', 0, true, '&parent_id=<%=directoryId%>');
		}
		
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteFilePermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, 'FILE', itemId);
		}
		function deleteDirectoryPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, 'DIRECTORY', itemId);
		}
		function setOwner()
		{
			Table.setOwnerOfItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'SetOwnerOfItems');
		}
		function shareDirectory(itemId)
		{
			Main.openPopup('../directories/index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id='+itemId, 'ShareDirectory', 600, 400);
		}
		function shareFile(itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id='+itemId, 'ShareFile', 600, 400);
		}
		function shareItems()
		{
			Table.shareItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'ShareItems');
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			var frm = document.forms[formId];
			updateSelected(Forms.getCheckedRadio(frm.item_id));
			// Table.returnSelected(formId, <%=callback != null ? "window.top.opener."+callback : "null" %>);
			window.top.returnSelected();
			window.top.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}

		function updateSelected(radio)
		{
			window.top.setSelected(radio.value, radio.title);
			//window.top.document.forms[0].file.value = radio.title;
		}
		function moveToDirectory(directoryId, path)
		{
			var frm = document.forms[formId]
			numChecked = Forms.numChecked(frm);
			if (!directoryId)
			{
				if (numChecked == 0)
				{
					alert('Please select at least one item in the list');
					return; 
				}
				Main.openPopup('../directories/index.jsp?ID=<%=ID%>&mode=selectonedirectory&title=Move+to&directory_id=<%=directoryId%>&callback=moveToDirectory', 'SelectDirectory', 400, 540);
			}
			else if (numChecked > 0)
			{
				Forms.createHidden(frm, 'newdirectory_id', directoryId);
				frm.action = submitPage;
				frm.cmd.value = 'MoveToDirectory';
				frm.submit();
			}
		}
		function moveTo(location)
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			if (location == <%=Location.OFFLINE.getValue()%>)
			{
				var msg = "This action will remove the file data of the selected file(s) from the server.\n";
				msg += "If you need the data again you have to re-upload the file(s).\n\n";
				msg += "Continue?";
				if (!confirm(msg)) return;	
			}
			Forms.createHidden(frm, 'move', location);
			frm.action = submitPage;
			frm.cmd.value = 'MoveItems';
			frm.submit();
		}
		function selectDirectory(subDirId)
		{
			parent.frames.directories.synchronizeTo(subDirId, <%=directoryId%>);
		}
		function updateSearchResults()
		{
			<%
			if (isSearch)
			{
				%>
				parent.frames.directories.updateSearchResults(<%=numFiles%>, <%=numDirectories%>);
				<%
			}
			%>
		}
		</script>
	</base:head>
	
	<base:body style="padding-left: 0px; padding-right: 0px;" onload="updateSearchResults()">
	<m:menu 
		id="move"
		style="display: none;">
	
		<m:menuitem 
			title="To another directory&hellip;" 
			onclick="moveToDirectory()"
			tooltip="Move the selected files and directories to another directory"
		/>
		<m:menuseparator />
		<m:menuitem 
			title="Offline&hellip;" 
			onclick="moveTo(0)"
			tooltip="Remove the selected files from the server (immedately)"
		/>
		<%
		if (Application.hasSecondaryStorage())
		{
			%>
			<m:menuitem 
				title="To primary location" 
				onclick="moveTo(1)"
				tooltip="Enqueue the selected files to be moved back to primary storage"
			/>
			<m:menuitem 
				title="To secondary location" 
				onclick="moveTo(2)"
				tooltip="Enqueue the selected files to be moved to secondary storage"
			/>
			<%
		}
		%>
		
	</m:menu>
	<div id="main">
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="files" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subcontext%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="subcontext" 
				value="<%=subcontext%>"
				skip="<%=subcontext == null%>" 
			/>
			<tbl:hidden 
				name="directory_id" 
				value="<%=Integer.toString(directoryId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				clazz="uniquecol"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef
				id="path"
				title="Path"
				property="directory.name"
				tooltip="Only the immediate parent directory can be searched or sorted"
				datatype="string"
				sortable="true"
				filterable="true"
				exportable="true"
				show="<%=isSearch ? "always" : "never" %>"
			/>
			<tbl:columndef 
				id="url"
				property="url"
				datatype="string"
				title="URL"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="fileServer"
				property="fileServer.name"
				datatype="string"
				title="File server"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="size"
				property="size"
				datatype="long"
				title="Size"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=bytes%>"
			/>
			<tbl:columndef 
				id="compressedSize"
				property="compressedSize"
				datatype="long"
				title="Compressed size"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=bytes%>"
			/>
			<tbl:columndef 
				id="compressed"
				property="compressed"
				datatype="boolean"
				title="Is compressed"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="writeProtected"
				property="writeProtected"
				datatype="boolean"
				title="Write protected"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			Enumeration<String, String> fileTypes = new Enumeration<String, String>();
			fileTypes.add("", "- none -");
			for (FileType ft : typeQuery.list(dc))
			{
				fileTypes.add(Integer.toString(ft.getId()), ft.getName());
			}
			%>
			<tbl:columndef 
				id="fileType"
				property="fileType"
				sortproperty="fileType.name"
				exportproperty="fileType.name"
				datatype="int"
				enumeration="<%=fileTypes%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="mimeType"
				property="mimeType"
				datatype="string"
				title="Mime type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="characterSet"
				property="characterSet"
				datatype="string"
				title="Character set"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			Enumeration<String, String> locations = new Enumeration<String, String>();
			for (Location l : Location.values())
			{
				locations.add(Integer.toString(l.getValue()), l.toString());
			}
			%>
			<tbl:columndef 
				id="location"
				property="location"
				datatype="int"
				enumeration="<%=locations%>"
				title="Location"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			Enumeration<String, String> actions = new Enumeration<String, String>();
			for (File.Action a : File.Action.values())
			{
				actions.add(Integer.toString(a.getValue()), a.toString());
			}
			%>
			<tbl:columndef 
				id="action"
				property="action"
				datatype="int"
				enumeration="<%=actions%>"
				title="Action"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="md5"
				property="md5"
				datatype="string"
				title="MD5"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="lastUpdate"
				property="lastUpdate"
				datatype="timestamp"
				title="Last update"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateTimeFormatter%>"
			/>
			<tbl:columndef 
				id="actions"
				title="Actions" 
				sortable="false" 
				filterable="false" 
				exportable="false"
			/>
			<tbl:columndef
				id="permissions"
				title="Permissions"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:toolbar
				visible="true" 
				>
				<tbl:button 
					disabled="<%=createDirectoryPermission ? false : true%>" 
					image="<%=createDirectoryPermission ? "directory_new.gif" : "directory_new_disabled.gif"%>" 
					onclick="newDirectory()" 
					title="New directory&hellip;" 
					visible="<%=!isSearch%>"
					tooltip="<%=createDirectoryPermission ? "Create a new directory" : "You do not have permission to create directories"%>" 
				/>
				<tbl:button 
					disabled="<%=createFilePermission ? false : true%>" 
					image="<%=createFilePermission ? "upload.gif" : "upload_disabled.gif"%>" 
					onclick="uploadFile(0)" 
					title="Upload file&hellip;" 
					visible="<%=!isSearch%>"
					tooltip="<%=createFilePermission ? "Upload a new file" : "You do not have permission to upload files"%>" 
				/>
				<tbl:button 
					disabled="<%=createFilePermission ? false : true%>" 
					image="<%=createFilePermission ? "url_new.png" : "url_new_disabled.png"%>" 
					onclick="editFile(0)" 
					title="New URL&hellip;" 
					visible="<%=!isSearch%>"
					tooltip="<%=createFilePermission ? "Create new URL reference" : "You do not have permission to create files"%>" 
				/>
				<tbl:button 
					image="delete.gif"
					onclick="deleteItems()" 
					title="Delete" 
					tooltip="Delete the selected items" 
					visible="<%=mode.hasToolbar()%>"
				/>
				<tbl:button 
					image="restore.gif"
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="Restore the selected (deleted) items"
					visible="<%=mode.hasToolbar()%>"
				/>
				<tbl:button 
					image="move.gif"
					onclick="Menu.toggleTopMenu(document.getElementById('move'), event.clientX, event.clientY); event.cancelBubble = true;" 
					title="Move&hellip;" 
					tooltip="Move the selected items"
					visible="<%=mode.hasToolbar()%>"
				/>
				<tbl:button 
					image="share.gif"
					onclick="shareItems()" 
					title="Share&hellip;" 
					tooltip="Share the selected items"
					visible="<%=mode.hasToolbar()%>"
				/>
				<tbl:button 
					image="take_ownership.png"
					onclick="setOwner()" 
					title="Set owner&hellip;"
					tooltip="Change owner of the selected items"
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
					visible="<%=mode.hasToolbar()%>"
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=!isSearch && pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=!isSearch && pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=!isSearch && pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:panel visible="<%=!isSearch%>">
				<%=current.getPath().toString()%>
			</tbl:panel>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=numFiles + numDirectories%>" 
				visible="<%=isSearch && mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
				
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>

					<tbl:rows>
					<%
					int index = 0;
					int selectedItemId = cc.getId();
					
					ItemContext dirContext = sc.getCurrentContext(Item.DIRECTORY);
					if (directories != null)
					{
						while (directories.hasNext())
						{
							index++;
							numListed++;
							Directory item = directories.next();
							int itemId = item.getId();
							String openSharePopup = "shareDirectory("+itemId+")";
							String deletePermanently = "deleteDirectoryPermanently("+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							String name = HTML.encodeTags(item.getName());
							String path = item.getPath().toString();
							String tagPath = HTML.encodeTags(path);
							String icon = item.getAutoCompress() ? "directory_compressed.gif" : "directory.gif";
							Directory parent = null;
							try
							{
								parent = item.getParent();
							}
							catch (Throwable t)
							{}
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><base:icon 
										image="<%=icon%>" 
										tooltip="<%=tagPath%>"
										onclick="<%="selectDirectory(" + itemId + ")"%>"
									/></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="D:<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=dirContext.getSelected().contains(itemId) ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="<%=deletePermission ? "deleted.gif" : "deleted_disabled.gif"%>"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="<%=sharePermission ? "shared.gif" : "shared_disabled.gif"%>" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" onclick="directoryOnClick(event, <%=itemId%>)" title="Edit this directory"><%=name%></div></tbl:cell>
								<tbl:cell column="path" style="white-space: nowrap;">
									<%
									if (parent != null && mode.hasPropertyLink())
									{
										%>
										<div class="link" onclick="selectDirectory(<%=parent.getId()%>)" title="Open this directory"><%=tagPath.substring(0, tagPath.length() - name.length())%></div>
										<%
									}
									else
									{
										%>
										<%=tagPath.substring(0, tagPath.length() - name.length())%>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="url">&nbsp;</tbl:cell>
								<tbl:cell column="fileServer">&nbsp;</tbl:cell>
								<tbl:cell column="size">&nbsp;</tbl:cell>
								<tbl:cell column="compressedSize">&nbsp;</tbl:cell>
								<tbl:cell column="compressed"><%=item.getAutoCompress() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="fileType">&nbsp;</tbl:cell>
								<tbl:cell column="mimeType">&nbsp;</tbl:cell>
								<tbl:cell column="characterSet">&nbsp;</tbl:cell>
								<tbl:cell column="md5">&nbsp;</tbl:cell>
								<tbl:cell column="location">&nbsp;</tbl:cell>
								<tbl:cell column="action">&nbsp;</tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="lastUpdate">&nbsp;</tbl:cell>
								<tbl:cell column="actions">&nbsp;</tbl:cell>
								<tbl:cell column="permissions"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										out.write(Base.getLinkedName(ID, sharees.next(), false, mode.hasEditLink()));
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
							</tbl:row>
						<%
						}
					}
					if (files != null)
					{						
						while (files.hasNext())
						{
							File item = files.next();
							int itemId = item.getId();
							Location location = item.getLocation();
							String openSharePopup = "shareFile("+itemId+")";
							String deletePermanently = "deleteFilePermanently("+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ?
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							String path = item.getPath().toString();
							String tagPath = HTML.encodeTags(path);
							String icon = "file.gif";
							if (location == Location.EXTERNAL) 
							{
								icon = "url.png";
							}
							else if (item.isCompressed())
							{
								icon = "file_compressed.gif";
							}
							String fileSize = Values.formatBytes(item.getSize(), numDecimals);
							index++;
							numListed++;
							Directory parent = null;
							try
							{
								parent = item.getDirectory();
							}
							catch (Throwable t)
							{}
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><base:icon 
										image="<%=icon%>" 
										tooltip="<%=tagPath%>"
									/></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=tagPath%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
										onclick="updateSelected(this)"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="<%=deletePermission ? "deleted.gif" : "deleted_disabled.gif"%>"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="<%=sharePermission ? "shared.gif" : "shared_disabled.gif"%>" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="fileOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="path" style="white-space: nowrap;">
									<%
									if (parent != null && mode.hasPropertyLink())
									{
										%>
										<div class="link" onclick="selectDirectory(<%=parent.getId()%>)" title="Open this directory"><%=tagPath.substring(0, tagPath.length() - name.length())%></div>
										<%
									}
									else
									{
										%>
										<%=tagPath.substring(0, tagPath.length() - name.length())%>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="url"><%=HTML.niceFormat(item.getUrl(), HTML.LINK_URL)%></tbl:cell>
								<tbl:cell column="fileServer"><base:propertyvalue 
										item="<%=item%>" 
										property="fileServer"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="size"><span title="<%=item.getSize()%> bytes"><%=fileSize%></span></tbl:cell>
								<tbl:cell column="compressedSize"><span title="<%=item.getCompressedSize()%> bytes"><%=Values.formatBytes(item.getCompressedSize(), numDecimals)%></span></tbl:cell>
								<tbl:cell column="compressed"><%=item.isCompressed() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="writeProtected"><%=item.isWriteProtected() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="fileType"
									><base:propertyvalue 
										item="<%=item%>" 
										property="fileType"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="mimeType"><%=HTML.encodeTags(item.getMimeType())%></tbl:cell>
								<tbl:cell column="characterSet"><%=HTML.encodeTags(item.getCharacterSet())%></tbl:cell>
								<tbl:cell column="location"><%=item.getLocation()%></tbl:cell>
								<tbl:cell column="action"><%=item.getAction()%></tbl:cell>
								<tbl:cell column="md5"><%=HTML.encodeTags(item.getMd5())%></tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="lastUpdate" value="<%=item.getLastUpdate()%>" />
								<tbl:cell column="actions">
									<%
									if (location.isDownloadable())
									{
										%>
										<a href="javascript:Main.viewFile('<%=ID%>', <%=itemId%>)"><base:icon image="view.gif" tooltip="<%="View the contents of this file (" + fileSize + ")"%>" /></a>
										<a href="javascript:Main.downloadFile('<%=ID%>', <%=itemId%>)"><base:icon image="download.gif" tooltip="<%="Download the contents of this file (" + fileSize + ")"%>" /></a>
										<%
									}
									else if (location == Location.OFFLINE)
									{
										%>
										<a href="javascript:uploadFile(<%=itemId%>)"><base:icon image="upload.gif" tooltip="Upload this file again" /></a>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="permissions"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
				<%
				if (numListed == 0)
				{
					%>
					<tbl:panel visible="<%=!isSearch || hasFilter%>">No files or directories were found</tbl:panel>
					<tbl:panel visible="<%=isSearch && !hasFilter%>">Please specify a search condition!</tbl:panel>
					<%
				}
				else
				{
					%>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=numFiles + numDirectories%>" 
						visible="<%=isSearch && mode.hasNavigator()%>"
						locked="true"
					/>
					<%
				}
			%>
		</tbl:table>
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (files != null) files.close();
	if (directories != null) directories.close();
	if (dc != null) dc.close();
}
%>
