<%-- $Id: edit_batch.jsp 5451 2010-10-26 12:55:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ARRAYBATCH;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ArrayBatch batch = null;
	
	boolean readCurrentArrayDesign = true;
	ArrayDesign currentArrayDesign = null;
	ArrayDesign defaultArrayDesign = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	Protocol defaultProtocol = null;
	boolean readCurrentPrintRobot = true;
	Hardware currentPrintRobot = null;
	Hardware defaultPrintRobot = null;

	// Load recently used items
	List<ArrayDesign> recentArrayDesigns = (List<ArrayDesign>)cc.getRecent(dc, Item.ARRAYDESIGN);
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Hardware> recentPrintRobots = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultArrayDesign = (ArrayDesign)activeProject.getDefaultItem(dc, Project.Default.ARRAYDESIGN);
		}
		catch (PermissionDeniedException pdex)
		{
			defaultArrayDesign = null;
		}
		try
		{
			defaultProtocol = (Protocol)activeProject.getDefaultItem(dc, Project.Default.PRINTING_PROTOCOL);
		}
		catch (PermissionDeniedException pdex)
		{
			defaultProtocol = null;
		}
		try
		{
			defaultPrintRobot = (Hardware)activeProject.getDefaultItem(dc, Project.Default.PRINTROBOT_HARDWARE);
		}
		catch (PermissionDeniedException pdex)
		{
			defaultPrintRobot = null;
		}
	}
	if (itemId == 0)
	{
		title = "Create array batch";
		cc.removeObject("item");
		int arrayDesignId = Values.getInt(request.getParameter("arraydesign_id"));
		if (arrayDesignId != 0)
		{
			currentArrayDesign = ArrayDesign.getById(dc, arrayDesignId);
		}
		else if (cc.getPropertyFilter("arrayDesign.name") != null)
		{
			currentArrayDesign = Base.getFirstMatching(dc, ArrayDesign.getQuery(), "name", cc.getPropertyFilter("arrayDesign.name"));
		}
		if (cc.getPropertyFilter("printRobot.name") != null)
		{
			currentPrintRobot = Base.getFirstMatching(dc, Hardware.getQuery(), "name", cc.getPropertyFilter("printRobot.name"));
		}
		if (cc.getPropertyFilter("protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("protocol.name"));
		}
	}
	else
	{
		batch = ArrayBatch.getById(dc, itemId);
		cc.setObject("item", batch);
		title = "Edit array batch -- " + HTML.encodeTags(batch.getName());
		try
		{
			currentArrayDesign = batch.getArrayDesign();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArrayDesign = false;
		}
		try
		{
			currentPrintRobot = batch.getPrintRobot();			
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPrintRobot = false;
		}
		try
		{
			currentProtocol = batch.getProtocol();			
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
	}
	if (batch != null && !batch.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "ArrayBatch" tab
		function validateArrayBatch()
		{
			var frm = document.forms['batch'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.arraydesign_id && frm.arraydesign_id[frm.arraydesign_id.selectedIndex].value == 0)
			{
				alert("You must select an array design");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['batch'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=batch == null ? 0 : batch.getId()%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['batch'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}

		function getParents()
		{
			var frm = document.forms['batch'];
			var parents = new Array();
			if (frm.arraydesign_id)
			{
				var arrayDesignId = Math.abs(parseInt(frm.arraydesign_id[frm.arraydesign_id.selectedIndex].value));
				if (arrayDesignId > 0) parents[parents.length] = 'ARRAYDESIGN:'+arrayDesignId;
			}
			return parents;
		}

		function arrayDesignOnChange()
		{
			parentsChanged = true;
		}
		function selectArrayDesignOnClick()
		{
			var frm = document.forms['batch'];
			var url = '../../lims/arraydesigns/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArrayDesignCallback';
			if (frm.arraydesign_id.length > 0) 
			{
				var id = Math.abs(parseInt(frm.arraydesign_id[0].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectArrayDesign', 1000, 700);
		}
		function setArrayDesignCallback(id, name)
		{
			var frm = document.forms['batch'];
			var list = frm.arraydesign_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
			parentsChanged = true;
		}

		function selectProtocolOnClick()
		{
			var frm = document.forms['batch'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:protocolType=<%=SystemItems.getId(ProtocolType.PRINTING)%>';
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['batch'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}

		function selectPrintRobotOnClick()
		{
			var frm = document.forms['batch'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPrintRobotCallback';
			if (frm.printrobot_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.printrobot_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:hardwareType=<%=SystemItems.getId(HardwareType.PRINT_ROBOT)%>';
			Main.openPopup(url, 'SelectPrintRobot', 1000, 700);
		}
		function setPrintRobotCallback(id, name)
		{
			var frm = document.forms['batch'];
			var list = frm.printrobot_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		
		function init()
		{
			var frm = document.forms['batch'];
			<%
			if (batch == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="batch" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=batch != null%>" switch="switchTab">
		<t:tab id="info" title="Array batch" validate="validateArrayBatch()" helpid="arraybatch.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(batch == null ? Values.getString(cc.getPropertyValue("name"), "New array batch") : batch.getName())%>" 
					size="40" maxlength="<%=ArrayBatch.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Array design</td>
				<td>
					<%
					if (batch != null)
					{
						%>
						<%=Base.getEncodedName(currentArrayDesign, !readCurrentArrayDesign)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="arraydesign_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentArrayDesign%>"
							denied="<%=!readCurrentArrayDesign%>"
							recent="<%=recentArrayDesigns%>"
							defaultitem="<%=defaultArrayDesign%>"
							newitem="true"
							onselect="selectArrayDesignOnClick()"
							onchange="arrayDesignOnChange()"
						/>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Print robot</td>
				<td>
					<base:select 
						id="printrobot_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentPrintRobot%>"
						denied="<%=!readCurrentPrintRobot%>"
						recent="<%=recentPrintRobots%>"
						defaultitem="<%=defaultPrintRobot%>"
						newitem="<%=batch == null%>"
						onselect="selectPrintRobotOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitem="<%=defaultProtocol%>"
						newitem="<%=batch == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(batch == null ? cc.getPropertyValue("description") : batch.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'batch', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
