<%-- $Id: view_feature.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.ArrayDesignBlock"
	import="net.sf.basedb.core.Feature"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.data.FeatureData"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.FEATURE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int arrayDesignId = Values.getInt(request.getParameter("arraydesign_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	final ArrayDesign design = ArrayDesign.getById(dc, arrayDesignId);
	
	final boolean isAffy = design.isAffyChip();
	FeatureData feature = design.getFeatureById(itemId, true);
	
	ArrayDesignBlock block = Feature.getArrayDesignBlock(dc, feature);
	
	String title = "Feature of "+HTML.encodeTags(design.getName()) + " at position " + feature.getPosition();
	%>

	<base:page title="<%=title%>" type="popup">
	<base:head styles="toolbar.css">
		<script language="JavaScript">
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 540, 460);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<h3 class="docked"><%=title%> <base:help helpid="feature.view.properties" /></h3>
		<div class="boxed" style="height: <%=(int)(scale*440)%>px; overflow: auto;">
			<h4>Array design</h4>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(design.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Platform / Variant</td>
				<td><base:propertyvalue item="<%=design%>" property="platform" /> / <base:propertyvalue item="<%=design%>" property="variant" /></td>
			</tr>
			<tr>
				<td class="prompt">Feature identification method</td>
				<td><%=design.getFeatureIdentificationMethod()%></td>
			</tr>
			</table>
			
			<h4>Feature / block</h4>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Feature ID</td>
				<td colspan="7"><%=HTML.encodeTags(feature.getExternalId())%></td>
			</tr>
			<tr>
				<td class="prompt">Position</td>
				<td><%=feature.getPosition()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Meta grid X</td>
				<td><%=block.getMetaGridX()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Meta grid Y</td>
				<td><%=block.getMetaGridY()%></td>
			</tr>
			<tr>
				<td class="prompt">Row</td>
				<td><%=feature.getRow()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Block size X</td>
				<td><%=block.getBlockSizeX()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Block size Y</td>
				<td><%=block.getBlockSizeY()%></td>
			</tr>
			<tr>
				<td class="prompt">Column</td>
				<td><%=feature.getColumn()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Origin X</td>
				<td><%=block.getOriginX()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Origin Y</td>
				<td><%=block.getOriginY()%></td>
			</tr>
			<tr>
				<td class="prompt">Block number</td>
				<td><%=block.getBlockNumber()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Spacing X</td>
				<td><%=block.getSpacingX()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Spacing Y</td>
				<td><%=block.getSpacingY()%></td>
			</tr>
			<tr>
				<td class="prompt">Diameter</td>
				<td><%=block.getFeatureDiameter()%></td>
			</tr>
			</table>
			
			<h4>Plate / well</h4>
			<%
			Well well = null;
			boolean readWell = true;
			try
			{
				well = Feature.getWell(dc, feature);
			}
			catch (PermissionDeniedException ex)
			{
				readWell = false;
			}
			if (!readWell)
			{
				%>
				<i>- denied -</i>
				<%
			}
			else if (well == null)
			{
				%>
				<i>- none -</i>
				<%
			}
			else
			{
				Plate plate = well.getPlate();
				%>
				<table  class="form" cellspacing=0>
				<tr>
					<td class="prompt">Plate</td>
					<td><%=HTML.encodeTags(plate.getName())%></td>
				</tr>
				<tr>
					<td class="prompt">Row</td>
					<td><%=rowFormatter.format(well.getRow())%></td>
				</tr>
				<tr>
					<td class="prompt">Column</td>
					<td><%=columnFormatter.format(well.getColumn())%></td>
				</tr>
				</table>
				<%
			}
			%>

			<h4>Reporter</h4>
			<%
			ReporterData reporter = feature.getReporter();
			if (reporter == null)
			{
				%>
				<i>- none -</i>
				<%
			}
			else
			{
				boolean readCurrentReporterType = true;
				ReporterType currentReporterType = null;
				try
				{
					currentReporterType = Reporter.getReporterType(dc, reporter);
				}
				catch (PermissionDeniedException ex)
				{
					readCurrentReporterType = false;
				}
				%>
				<table border="0" cellspacing="0" cellpadding="0">
				<tr valign="top">
				<td>
					<table class="form" cellspacing=0>
					<tr>
						<td class="prompt">Name</td>
						<td><%=HTML.encodeTags(reporter.getName())%></td>
					</tr>
					<tr>
						<td class="prompt">External ID</td>
						<td><%=HTML.encodeTags(reporter.getExternalId())%></td>
					</tr>
					<tr>
						<td class="prompt">Type</td>
						<td><%=Base.getEncodedName(currentReporterType, !readCurrentReporterType)%></td>
					</tr>
					<tr>
						<td class="prompt">Gene symbol</td>
						<td><%=HTML.encodeTags(reporter.getSymbol())%></td>
					</tr>
					<tr valign="top">
						<td class="prompt">Description</td>
						<td><%=HTML.niceFormat(reporter.getDescription())%></td>
					</tr>
					<tr>
						<td class="prompt">Registered</td>
						<td><%=dateFormatter.format(reporter.getEntryDate())%></td>
					</tr>
					<tr>
						<td class="prompt">Last update</td>
						<td><%=dateTimeFormatter.format(reporter.getLastUpdate())%></td>
					</tr>
					</table>
				</td>
				<td>&nbsp;&nbsp;</td>
				<td>
					<table class="form" cellspacing=0>
					<%
					List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
					if (reporterProperties != null)
					{
						boolean needsTr = true;
						for (ExtendedProperty ep : reporterProperties)
						{
							String name = ep.getName();
							Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
							String value = f.format(reporter.getExtended(name));
							%>
								<%=needsTr ? "<tr valign=\"top\">" : "" %>
								<td class="prompt"><%=HTML.encodeTags(ep.getTitle())%></td>
								<td><%=value%></td>
								<td>&nbsp;&nbsp;</td>
								<%=needsTr ? "" : "</tr>"%>
							<%
							needsTr = !needsTr;
						}
						%>
						<%=needsTr ? "" : "</tr>"%>
						<%
					}
					%>
					</table>
				</td>
				</tr>
				</table>
				<%
			}
			%>
		</div>

		<div align="center">
			<table>
			<tr>
			<td><base:button onclick="window.close()" title="Close" /></td>
			</tr>
			</table>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
